// Timer 0 take as interrupt 
// Timer 1 take as interrupt

#include <reg51.h>

// ŧiɨ禡
void delay_1500ms(void);

unsigned int timer0_counter = 150;
unsigned int timer1_counter = 150;
int seg_pos = 0, seg_num = 0;
int LED_mode = 0;
//LED
bit lightoff = 1;
bit lighton = 0;

char code LED_light[17] = {
	~0x00,
	~0x01,	
	~0x03,  
	~0x07,  
	~0x0F,  
	~0x1F,  
	~0x3F,  
	~0x7F,  
	~0xFF,  
	~0x7F,  
	~0x3F,
	~0x1F,	
	~0x0F,  
	~0x07,  
	~0x03,  
	~0x01
};

//Segment
// ŧi D Ͼ󱵸}
sbit P2_6 = P2^6;
sbit P2_7 = P2^7;

// ŧiCqܾ禡
void Slect_Seg(unsigned char number);
void Display_Seg(unsigned char display);

//ŧiƦr
char code NUM[10] = {
	0x3F,		// 0
	0x06,   // 1 
	0x5B,   // 2
	0x4F,   // 3
	0x66,   // 4
	0x6D,   // 5
	0x7D,   // 6
	0x07,   // 7
	0x7F,   // 8
	0x6F  	// 9
};

char code POS[6] = {
	~0x01, // 0xfe NO 11111110
	~0x02, // 0000 0010
	~0x04, // 0000 0100
	~0x08, // 0000 1000
	~0x10, // 0001 0000
	~0x20  // 0010 0000
};


void main(void){
	
	//} Timer0 M Timer1
	TMOD = 0x11;

	//interrupt control (timer0)
	TL0 = (65536 - 9216) % 256;
	TH0 = (65536 - 9216) / 256;
	TF0 = 0;
	TR0 = 1;	//}ҭpɾ timer0
	ET0 = 1;	//} TF0 _Ҳն}
	EA = 1;		//}Ҥ_Ҳ`}
	
	
	//interrupt control (timer1)
	TL1 = (65536 - 9216) % 256;
	TH1 = (65536 - 9216) / 256;
	TF1 = 0;
	TR1 = 1;	//}ҭpɾ timer0
	ET1 = 1;	//} TF0 _Ҳն}
}


// timer0 bpɨ쪺ɭ(TF0 = 1)|Is_ƨ禡
void my_timer0(void) interrupt 1 {
		
	//]wl
	TL0 = (65536 - 9216) % 256;
	TH0 = (65536 - 9216) / 256;
  TF0 = 0;
	
  // timer0_counter @
	timer0_counter--;
	
	
	// timer0_counter  0 ɡA@Cqܾ
  if (timer0_counter == 0){
    
		// *********@Cqܾ*********
		Slect_Seg(POS[seg_pos]);  // ]wG
		Display_Seg(NUM[seg_num]);  // Ʀr
		seg_pos = (seg_pos + 1) % 6;
		seg_num = (seg_num + 1) % 10;
		
		//N timer0_counter ȳ]^ 150
    timer0_counter = 150;
		
  }
}


// timer1 bpɨ쪺ɭ(TF1 = 1)|Is_ƨ禡
void my_timer1(void) interrupt 3 {
		
	//]wl
	TL1 = (65536 - 9216) % 256;
	TH1 = (65536 - 9216) / 256;
  TF1 = 0;
	
  // timer1_counter @
	timer1_counter--;
	
	
	// timer1_counter  0 ɡA@Cqܾ
  if (timer1_counter == 0){
    
		// ********* @ LED *********
		for(LED_mode = 0; LED_mode < 16; LED_mode++) {
			P1 = LED_light[LED_mode];
		}
		
		//N timer0_counter ȳ]^ 150
    timer1_counter = 150;
		
  }
}


void Slect_Seg(unsigned char number) {
	int j = 0;
	
  //  D Ͼ(wI)
  P2_7 = 0;
  
  // wG
  P0 = number;
  
  // }ұG D Ͼ
  P2_7 = 1;
	
  // (YG)
  for(j = 0; j < 120; j++);

  //  D Ͼ(YihTwG)
  P2_7 = 0;
}

void Display_Seg(unsigned char display) {
  int j = 0;
  //  D Ͼ(wI)
  P2_6 = 0;
  
  // wX
  P0 = display;
  
  // }ұG D Ͼ
  P2_6 = 1;
	
  // (YX)
  for(j = 0; j < 120; j++);

  //  D Ͼ(YihXTw)
  P2_6 = 0;
}
